(setq gnutls-algorithm-priority "NORMAL:-VERS-TLS1.3")
(require 'package)
(setq package-enable-at-startup nil)
(add-to-list 'package-archives '("gnu" . "https://elpa.gnu.org/packages/"))
(add-to-list 'package-archives '("melpa" . "https://melpa.org/packages/"))
(setq vc-follow-symlinks nil)
(defalias 'yes-or-no-p 'y-or-n-p)

;; enable python for in-buffer evaluation
(org-babel-do-load-languages
 'org-babel-load-languages
 '((python . t)))



(package-initialize)

;; Bootstrap `use-package`
(unless (package-installed-p 'use-package)
  (package-refresh-contents)
  (package-install 'use-package))

;; ORG DOWNLOAD
(use-package org-download
		 :ensure t)


(org-babel-load-file (expand-file-name "~/.emacs.d/myinit.org"))

(setq inhibit-splash-screen t)

;;Eclipse-like C-backspace
(defun my-kill-back ()
  (interactive)
  (if (bolp)  ; beginnning of line, just delete 1
      (backward-delete-char 1)
    (if (string-match "[^[:space:]]" (buffer-substring (point-at-bol) (point)))
        ; There's a word on the line, delete it
        (backward-kill-word 1)
      (delete-region (point-at-bol) (point))))) ; all whitespace, delete it

 (global-set-key [C-backspace] 'my-kill-back)


;(setq initial-buffer-choice "*Org Agenda*")
;(org-agenda-list 1)
;(delete-other-windows)
(defun custom-startup ()
  (interactive)
  (org-agenda-list 1)
  (delete-other-windows))
(add-hook 'after-init-hook 'custom-startup)


;;(tool-bar-mode -1)
;;(menu-bar-mode -1)
;;(scroll-bar-mode -1)
;;(load-theme 'wombat)
(custom-set-variables
 ;; custom-set-variables was added by Custom.
 ;; If you edit it by hand, you could mess it up, so be careful.
 ;; Your init file should contain only one such instance.
 ;; If there is more than one, they won't work right.
 '(ansi-color-names-vector
   ["#303030" "#ff4b4b" "#d7ff5f" "#fce94f" "#5fafd7" "#d18aff" "#afd7ff" "#c6c6c6"])
 '(custom-safe-themes
   (quote
    ("26d49386a2036df7ccbe802a06a759031e4455f07bda559dcf221f53e8850e69" "ef403aa0588ca64e05269a7a5df03a5259a00303ef6dfbd2519a9b81e4bce95c" default)))
 '(horizontal-scroll-bar-mode nil)
 '(menu-bar-mode nil)
 '(org-agenda-files
   (quote
    ("~/Documents/org/todo.org" "~/Documents/org/i.org" "~/Documents/org/habits.org" "~/Documents/org/links.org" "~/Documents/org/school.org")))
 '(package-selected-packages
   (quote
    (org-re-reveal-ref multiple-cursors org-re-reveal haskell-mode csharp-mode ess 2048-game ## gnu-elpa-keyring-update yapfify nix-mode doom-modeline doom-themes tao-theme poet-theme faff-theme zerodark-theme alect-themes moe-theme base16-theme zenburn-theme color-theme-modern counsel-spotify ggtags use-package)))
 '(safe-local-variable-values
   (quote
    ((eval add-hook
	   (quote after-save-hook)
	   (quote org-icalendar-export-to-ics)
	   nil t)
     (eval add-hook
	   (quote after-save-hook)
	   (quote org-icalendar-export-agenda-files)
	   nil t))))
 '(scroll-bar-mode nil)
 '(tool-bar-mode nil))
(custom-set-faces
 ;; custom-set-faces was added by Custom.
 ;; If you edit it by hand, you could mess it up, so be careful.
 ;; Your init file should contain only one such instance.
 ;; If there is more than one, they won't work right.
 '(org-agenda-calendar-event ((t (:inherit default :foreground "CadetBlue1"))))
 '(org-agenda-column-dateline ((t (:background "#4e4e4e" :foreground "gold" :underline t))))
 '(org-agenda-current-time ((t (:inherit org-time-grid :foreground "lawn green"))))
 '(org-agenda-filter-category ((t (:inherit mode-line))))
 '(org-level-1 ((t (:foreground "#5fafd7" :height 2.0))))
 '(org-level-2 ((t (:foreground "#a1db00" :height 1.75))))
 '(org-level-3 ((t (:foreground "#ff8700" :height 1.5))))
 '(org-level-4 ((t (:foreground "#00d7af" :height 1.25)))))
